#include <stdlib.h>
#include <time.h>

#include "Engine.h"
#include "Food.h"

/* * *
 * Create food on the heap memory at random location within board.
 * Return a pointer to food.
 * * */
Food_t* Food_Init(const Board* board) {
	// Allocate heap memory for food.
	Food_t* food = NULL;
	food = malloc(sizeof(Food_t) * 1);
	// Check for memory error - no more action.
	if (food == NULL) return NULL;
	// Get the size of the inside of board.
	unsigned int y = board->height - 1;
	unsigned int x = board->width - 1;
	// Assign coordinate.
	srand(time(0));
	food->yLoc  = rand() % y;
	food->xLoc  = rand() % x;
	// Make sure coordinates are inside the board - not on the edge.
	if (food->yLoc == 0) food->yLoc++;
	if (food->xLoc == 0) food->xLoc++;
	// Set value of food.
	food->vChar  = 'A';
	food->vGrow  = rand() % 4 + 1;
	// Return food.
	return food;
}

/* * *
 * Draw the food in the board according to food's coordinate.
 * * */
void Food_Draw(const Board* board, Food_t* food) {
	if (food != NULL) {
		// Print to board.
		mvwprintw(board->win, food->yLoc, food->xLoc, "%c", food->vChar);
		// Update changes to board window.
		wrefresh(board->win);
	}
}
